{
  regelmatige veelhoeken
  Matthijs Coster
  ps'apenstaart'coster.demon.nl
  Start               4 februari 2005
  Laatste wijziging: 13 februari 2005

  Met dit programma kunnen regelmatige veelhoeken worden getekend
  Indien men beschikt over een Postscript-viewer kan men deze tekeningen
  tevens printen. Ghostgum software biedt gratis dergelijke viewers aan.
  Adobe Acrobat Reader veroorzaakt foutmeldingen. Ik wordt gaarne op de
  hoogte gebracht indien dit euvel kan worden verholpen.

  Het scherm heeft de grootte overeenkomstig n vel A4. Door schaling kunnen
  grotere en kleinere objecten worden getekend.

  Postscript-bestanden worden weggeschreven naar de directory waar dit
  programma staat. De namen van de bestanden beginnen met het getal n,
  corresponderend met het aantal hoeken, en vervolgens hoek, ster of punt.
}

unit P_nhoek;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin;

const
  pslines : array[1..9] of string =
   ('%!PS-Adobe EPSF-3.0','%Author: Matthijs Coster',
    '%email: ps''apenstaart''coster.demon.nl',
    '%%BoundingBox 0 0','setlinewidth','newpath','closepath','stroke','showpage');
  pscolors : array[0..3] of string =
   ('0 0 0 setrgbcolor','1 0 0 setrgbcolor','0 1 0 setrgbcolor','0 0 1 setrgbcolor');
  MyBlack = 0;
  MyRed = 1;
  MyGreen = 2;
  MyBlue = 3;

type
  TF_nhoek = class(TForm)
    PaintBox1: TPaintBox;
    ListBox1: TListBox;
    Panel1: TPanel;
    Label3: TLabel;
    S_Nhoek: TSpinEdit;
    Label1: TLabel;
    S_Size: TSpinEdit;
    Label2: TLabel;
    S_Margin: TSpinEdit;
    R_HoekPunt: TRadioGroup;
    R_Kleur: TRadioGroup;
    B_Listing: TButton;
    B_Exit: TButton;
    S_dikte: TSpinEdit;
    Label4: TLabel;
    P_ster: TPanel;
    Label5: TLabel;
    S_Ster: TSpinEdit;
    R_Vulling: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure S_NhoekChange(Sender: TObject);
    procedure R_HoekPuntClick(Sender: TObject);
    procedure B_ListingClick(Sender: TObject);
    procedure B_ExitClick(Sender: TObject);
  private
    { Private declarations }
    procedure Paint; override;
  public
    { Public declarations }
    procedure DrawFunc;
    procedure DrawNHoek;
    procedure DrawNCombi;
    procedure DrawNSter;
    procedure DrawNPunt;
    procedure ListingNHoek;
    procedure ListingNSter;
    procedure ListingNPunt;
  end;

var
  F_nhoek: TF_nhoek;
  A4size, margin, n : integer;
  cosarr, sinarr : array[0..300] of real;

implementation

{$R *.DFM}

procedure snijden(i,j,k,l:integer;var x,y:real);
var lambda_t,lambda_n,xi,xj,xk,xl,yi,yj,yk,yl:real;
begin
{bepaal snijpunt (x,y) van c(i)-c(j) en c(k)-c(l)}
   xi:=cosarr[i];
   xj:=cosarr[j];
   xk:=cosarr[k];
   xl:=cosarr[l];
   yi:=sinarr[i];
   yj:=sinarr[j];
   yk:=sinarr[k];
   yl:=sinarr[l];
   lambda_t:=xk*yl-yk*xl-xi*yl+yi*xl+xi*yk-yi*xk;
   lambda_n:=(xj-xi)*(yl-yk)-(yj-yi)*(xl-xk);
   x:=xi+(xj-xi)*lambda_t/lambda_n;
   y:=yi+(yj-yi)*lambda_t/lambda_n;
end;

{algemene procedures}
procedure TF_nhoek.Paint;
begin
  inherited;
  DrawFunc;
end;

procedure TF_nhoek.FormCreate(Sender: TObject);
begin
  A4size := S_Size.value;
  Margin := S_Margin.value;
  n := S_Nhoek.value;
  S_NhoekChange(Sender);
end;

procedure TF_nhoek.R_HoekPuntClick(Sender: TObject);
begin
  P_ster.visible := (R_HoekPunt.ItemIndex = 3);
  DrawFunc;
end;

procedure TF_nhoek.S_NhoekChange(Sender: TObject);
var i, xm, ym, Mx, My : integer;
begin
  A4size := S_Size.value;
  Margin := S_Margin.value;
  n := S_Nhoek.value;
  if S_Ster.value > n div 2 - 1 then S_Ster.value := n div 2 - 1;
  S_Ster.maxvalue := n div 2 - 1;
  xm := A4size;
  ym := A4size;
  Mx := (xm+1) div 2;
  My := (ym+1) div 2;
  xm := xm-2*Margin;
  ym := ym-2*Margin;
  Try
    if n > 4 then
    for i := 0 to n do
    begin
      cosarr[i] := -cos(2*pi*((2*i-1)/(2*n)+1/4))*xm/2+Mx;
      sinarr[i] := -sin(2*pi*((2*i-1)/(2*n)+1/4))*ym/2+My;
    end;
    DrawFunc;
  Except
    On EIntError do ;
  end;
end;

{procedures t.b.v. tekenen op Paintbox}
procedure TF_nhoek.DrawFunc;
var
  i, j, k, m : integer;
begin
  with Paintbox1.Canvas do
  begin
    Pen.Color := clGray;
    Brush.Color := clWhite;
    Rectangle(0, 0, Paintbox1.Width, Paintbox1.Height);
    Pen.Width := 1;
    if R_HoekPunt.Itemindex = 0 then DrawNhoek else
    if R_HoekPunt.Itemindex = 1 then DrawNPunt else
    if R_HoekPunt.Itemindex = 2 then DrawNCombi else DrawNSter;
  end;
end;

procedure TF_nhoek.DrawNHoek;
var
  i, j, k, m : integer;
begin
  with Paintbox1.Canvas do
  begin
    if (n mod 2 = 0) AND (R_kleur.itemindex=1) then
    begin
      m := n div 2;
      Pen.Color := clGreen;
      for i := 0 to m-1 do
      for j := 0 to m-1 do
      begin
        k := i-j-1;
        if k<0 then k := k+n;
        moveto(round(sinarr[i+j]),round(cosarr[i+j]));
        lineto(round(sinarr[k]),round(cosarr[k]));
      end;
      Pen.Color := clBlack;
      for i := 0 to m-1 do
      for j := 1 to m-1 do
      begin
        k := i-j;
        if k<0 then k := k+n;
        moveto(round(sinarr[i+j]),round(cosarr[i+j]));
        lineto(round(sinarr[k]),round(cosarr[k]));
      end;
      Pen.Color := ClRed;
      for i := 0 to m-1 do
      begin
        moveto(round(sinarr[i]),round(cosarr[i]));
        lineto(round(sinarr[i+m]),round(cosarr[i+m]));
      end;
    end
    else if R_kleur.itemindex=1 then
    begin
      Pen.Color := clBlack;
      for i := 0 to n-1 do
      for j := i+1 to n do
      if ((2*(j-i)>n) AND ((j-i) mod 2 = 0)) OR ((2*(j-i)<n) AND ((j-i) mod 2 = 1)) then
      begin
        moveto(round(sinarr[i]),round(cosarr[i]));
        lineto(round(sinarr[j]),round(cosarr[j]));
      end;
      Pen.Color := clGreen;
      for i := 0 to n-1 do
      for j := i+1 to n do
      if ((2*(j-i)<n) AND ((j-i) mod 2 = 0)) OR ((2*(j-i)>n) AND ((j-i) mod 2 = 1)) then
      begin
        moveto(round(sinarr[i]),round(cosarr[i]));
        lineto(round(sinarr[j]),round(cosarr[j]));
      end;
    end
    else
    begin
      Pen.Color := clBlack;
      for i := 0 to n-1 do
      for j := i+1 to n do
      begin
        moveto(round(sinarr[i]),round(cosarr[i]));
        lineto(round(sinarr[j]),round(cosarr[j]));
      end;
    end;
  end;
end;

procedure TF_nhoek.DrawNPunt;
var
  x0, y0, x1, y1, xM, yM, factor : real;
  i, j, k, m : integer;
begin
  with Paintbox1.Canvas do
  begin
    if n mod 2 = 0 then
    begin
      m := n div 2;
      Pen.Color := clBlack;
      snijden(0,m,1,m+1,xM,yM);
      factor := (xM-Margin)/(xM-cosarr[0]);
      for i := 2 to m-1 do
      for j := i+m+1 to n-1 do
      begin
        snijden(0,m,i,j,x0,y0);
        snijden(1,m+1,i,j,x1,y1);
        moveto(Margin+round(factor*(y0-sinarr[0])),Margin+round(factor*(x0-cosarr[0])));
        lineto(Margin+round(factor*(y1-sinarr[0])),Margin+round(factor*(x1-cosarr[0])));
      end;
      if R_kleur.itemindex=1 then Pen.Color := clBlue;
      for i := 2 to m-1 do
      begin
        moveto(Margin,Margin);
        snijden(0,i,1,m+1,x0,y0);
        lineto(Margin+round(factor*(y0-sinarr[0])),Margin+round(factor*(x0-cosarr[0])));
        moveto(Margin,Margin+round(factor*(cosarr[1]-cosarr[0])));
        snijden(1,n-i+1,0,m,x0,y0);
        lineto(Margin+round(factor*(y0-sinarr[0])),Margin+round(factor*(x0-cosarr[0])));
      end;
      if R_kleur.itemindex=1 then Pen.Color := clRed;
      moveto(Margin,Margin);
      lineto(Margin,Margin+round(factor*(cosarr[1]-cosarr[0])));
      lineto(Margin+round(factor*(yM-sinarr[0])),Margin+round(factor*(xM-cosarr[0])));
      lineto(Margin,Margin);
    end
    else
    begin
      m := n div 2+1;
      factor := (cosarr[m]-Margin)/(cosarr[m]-cosarr[0]);
      Pen.Color := clBlack;
      for i := 2 to m-1 do
      for j := m+1 to n-1 do
      begin
        snijden(0,m,i,j,x0,y0);
        snijden(1,m,i,j,x1,y1);
        moveto(Margin+round(factor*(y0-sinarr[0])),Margin+round(factor*(x0-cosarr[0])));
        lineto(Margin+round(factor*(y1-sinarr[0])),Margin+round(factor*(x1-cosarr[0])));
      end;
      if R_kleur.itemindex=1 then Pen.Color := clBlue;
      for i := 2 to m-1 do
      begin
        moveto(Margin,Margin);
        snijden(0,i,1,m,x0,y0);
        lineto(Margin+round(factor*(y0-sinarr[0])),Margin+round(factor*(x0-cosarr[0])));
        moveto(Margin,Margin+round(factor*(cosarr[1]-cosarr[0])));
        snijden(1,n-i+1,0,m,x0,y0);
        lineto(Margin+round(factor*(y0-sinarr[0])),Margin+round(factor*(x0-cosarr[0])));
      end;
      if R_kleur.itemindex=1 then Pen.Color := clRed;
      moveto(Margin,Margin);
      lineto(Margin,Margin+round(factor*(cosarr[1]-cosarr[0])));
      lineto(Margin+round(factor*(sinarr[m]-sinarr[0])),Margin+round(factor*(cosarr[m]-cosarr[0])));
      lineto(Margin,Margin);
    end;
  end;
end;

procedure TF_nhoek.DrawNCombi;
var
  x0, y0, x1, y1, xM, yM : real;
  i, j, k, m : integer;
begin
  with Paintbox1.Canvas do
  begin
    if n mod 2 = 0 then
    begin
      m := n div 2;
      Pen.Color := clGreen;
      for i := 0 to m-1 do
      for j := 0 to m-1 do
      begin
        k := i-j-1;
        if k<0 then k := k+n;
        moveto(round(sinarr[i+j]),round(cosarr[i+j]));
        lineto(round(sinarr[k]),round(cosarr[k]));
      end;
      Pen.Color := clBlack;
      for i := 0 to m-1 do
      for j := 1 to m-1 do
      begin
        k := i-j;
        if k<0 then k := k+n;
        moveto(round(sinarr[i+j]),round(cosarr[i+j]));
        lineto(round(sinarr[k]),round(cosarr[k]));
      end;
      Pen.Color := ClRed;
      for i := 0 to m-1 do
      begin
        moveto(round(sinarr[i]),round(cosarr[i]));
        lineto(round(sinarr[i+m]),round(cosarr[i+m]));
      end;
      Pen.Color := clBlue;
      snijden(0,m,1,m+1,xM,yM);
      moveto(round(sinarr[0]),round(cosarr[0]));
      lineto(round(sinarr[1]),round(cosarr[1]));
      lineto(round(yM),round(xM));
      lineto(round(sinarr[0]),round(cosarr[0]));
      for i := 2 to m-1 do
      begin
        moveto(round(sinarr[0]),round(cosarr[0]));
        snijden(0,i,1,m+1,x0,y0);
        lineto(round(y0),round(x0));
        moveto(round(sinarr[1]),round(cosarr[1]));
        snijden(1,n-i+1,0,m,x0,y0);
        lineto(round(y0),round(x0));
      end;
      for i := 2 to m-1 do
      for j := i+m+1 to n-1 do
      begin
        snijden(0,m,i,j,x0,y0);
        snijden(1,m+1,i,j,x1,y1);
        moveto(round(y0),round(x0));
        lineto(round(y1),round(x1));
      end;
    end
    else
    begin
      m := n div 2+1;
      Pen.Color := clBlack;
      for i := 0 to n-1 do
      for j := i+1 to n do
      begin
        moveto(round(sinarr[i]),round(cosarr[i]));
        lineto(round(sinarr[j]),round(cosarr[j]));
      end;
      Pen.Color := clBlue;
      moveto(round(sinarr[0]),round(cosarr[0]));
      lineto(round(sinarr[1]),round(cosarr[1]));
      lineto(round(sinarr[m]),round(cosarr[m]));
      lineto(round(sinarr[0]),round(cosarr[0]));
      for i := 2 to m-1 do
      begin
        moveto(round(sinarr[0]),round(cosarr[0]));
        snijden(0,i,1,m,x0,y0);
        lineto(round(y0),round(x0));
        moveto(round(sinarr[1]),round(cosarr[1]));
        snijden(1,n-i+1,0,m,x0,y0);
        lineto(round(y0),round(x0));
      end;
      for i := 2 to m-1 do
      for j := m+1 to n-1 do
      begin
        snijden(0,m,i,j,x0,y0);
        snijden(1,m,i,j,x1,y1);
        moveto(round(y0),round(x0));
        lineto(round(y1),round(x1));
      end;
    end;
  end;
end;

procedure TF_nhoek.DrawNSter;
var
  i, j, k, m, s : integer;
begin
  s := S_Ster.value;
  with Paintbox1.Canvas do
  begin
    if R_kleur.itemindex=1 then
    begin
      Pen.Color := clBlack;
      if R_vulling.ItemIndex = 0 then
      begin
        for i := 0 to n-1 do
        for j := i+s+2 to n do
        if j+s+1 < i+n then
        begin
          moveto(round(sinarr[i]),round(cosarr[i]));
          lineto(round(sinarr[j]),round(cosarr[j]));
        end;
        Pen.Color := clRed;
        if n mod 2 = 0 then
        begin
          m := n div 2;
          for i := 0 to m-1 do
          begin
            moveto(round(sinarr[i]),round(cosarr[i]));
            lineto(round(sinarr[i+m]),round(cosarr[i+m]));
          end;
        end;
      end;
      Pen.Color := clBlue;
      for i := 0 to n-1 do
      begin
        if i+s+1 < n then j := i+s+1 else j := i+s-n+1;
        moveto(round(sinarr[i]),round(cosarr[i]));
        lineto(round(sinarr[j]),round(cosarr[j]));
      end;
    end
    else
    begin
      Pen.Color := clBlack;
      if R_vulling.ItemIndex = 0 then
      begin
        for i := 0 to n-1 do
        for j := i+s+1 to n do
        if j+s < i+n then
        begin
          moveto(round(sinarr[i]),round(cosarr[i]));
          lineto(round(sinarr[j]),round(cosarr[j]));
        end;
      end
      else
      begin
        for i := 0 to n-1 do
        begin
          if i+s+1 < n then j := i+s+1 else j := i+s-n+1;
          moveto(round(sinarr[i]),round(cosarr[i]));
          lineto(round(sinarr[j]),round(cosarr[j]));
        end;
      end;
    end;
  end;
end;

{procedures t.b.v. tekenen op postscript}
procedure TF_nhoek.B_ListingClick(Sender: TObject);
var
  i, j, xm, ym, Mx, My : integer;
  s : string;
begin
  with Listbox1.Items do
  begin
    Clear;
    Add(pslines[1]);
    Add(pslines[2]);
    Add(pslines[3]);
    Add(pslines[4]+' '+IntToStr(A4size)+' '+IntToStr(A4size));
    Add('0.'+IntToStr(S_Dikte.value)+' '+pslines[5]);
    Add(pslines[6]);
  end;
  if R_HoekPunt.Itemindex = 1 then
  begin
    s := 'Punt.ps';
    ListingNPunt;
  end
  else if R_HoekPunt.Itemindex = 3 then
  begin
    s := 'Ster.ps';
    ListingNSter;
  end
  else
  begin
    s := 'Hoek.ps';
    ListingNHoek;
  end;
  with Listbox1.Items do
  begin
    Add(pslines[7]);
    Add(pslines[8]);
    Add(pslines[9]);
    SaveToFile(IntToStr(n)+s);
  end;
end;

procedure TF_nhoek.ListingNHoek;
var
  i, j, k, m : integer;
begin
  with Listbox1.Items do
  begin
    if (n mod 2 = 0) AND (R_kleur.itemindex=1) then
    begin
      m := n div 2;
      Add(pscolors[MyGreen]);
      for i := 0 to m-1 do
      for j := 0 to m-1 do
      begin
        k := i-j-1;
        if k<0 then k := k+n;
        add(inttostr(round(cosarr[i+j]))+' '+inttostr(round(sinarr[i+j]))+' moveto');
        add(inttostr(round(cosarr[k]))+' '+inttostr(round(sinarr[k]))+' lineto');
      end;
      Add(pslines[7]);
      Add(pslines[8]);
      Add(pslines[6]);
      Add(pscolors[MyBlack]);
      for i := 0 to m-1 do
      for j := 1 to m-1 do
      begin
        k := i-j;
        if k<0 then k := k+n;
        add(inttostr(round(cosarr[i+j]))+' '+inttostr(round(sinarr[i+j]))+' moveto');
        add(inttostr(round(cosarr[k]))+' '+inttostr(round(sinarr[k]))+' lineto');
      end;
      Add(pslines[7]);
      Add(pslines[8]);
      Add(pslines[6]);
      Add(pscolors[MyRed]);
      for i := 0 to m-1 do
      begin
        add(inttostr(round(cosarr[i]))+' '+inttostr(round(sinarr[i]))+' moveto');
        add(inttostr(round(cosarr[i+m]))+' '+inttostr(round(sinarr[i+m]))+' lineto');
      end;
    end
    else if R_kleur.itemindex=1 then
    begin
      for i := 0 to n-1 do
      for j := i+1 to n do
      if ((2*(j-i)>n) AND ((j-i) mod 2 = 0)) OR ((2*(j-i)<n) AND ((j-i) mod 2 = 1)) then
      begin
        add(inttostr(round(cosarr[i]))+' '+inttostr(round(sinarr[i]))+' moveto');
        add(inttostr(round(cosarr[j]))+' '+inttostr(round(sinarr[j]))+' lineto');
      end;
      Add(pslines[7]);
      Add(pslines[8]);
      Add(pslines[6]);
      Add(pscolors[MyGreen]);
      for i := 0 to n-1 do
      for j := i+1 to n do
      if ((2*(j-i)<n) AND ((j-i) mod 2 = 0)) OR ((2*(j-i)>n) AND ((j-i) mod 2 = 1)) then
      begin
        add(inttostr(round(cosarr[i]))+' '+inttostr(round(sinarr[i]))+' moveto');
        add(inttostr(round(cosarr[j]))+' '+inttostr(round(sinarr[j]))+' lineto');
      end;
    end
    else
    begin
      for i := 0 to n-1 do
      for j := i+1 to n do
      begin
        add(inttostr(round(cosarr[i]))+' '+inttostr(round(sinarr[i]))+' moveto');
        add(inttostr(round(cosarr[j]))+' '+inttostr(round(sinarr[j]))+' lineto');
      end;
    end;
  end;
end;

procedure TF_nhoek.ListingNPunt;
var
  x0, y0, x1, y1, xM, yM, factor : real;
  i, j, k, m : integer;
begin
  with Listbox1.Items do
  begin
    if n mod 2 = 0 then
    begin
      m := n div 2;
      snijden(0,m,1,m+1,xM,yM);
      factor := (xM-Margin)/(xM-cosarr[0]);
      if R_kleur.itemindex=1 then Add(pscolors[MyBlack]);
      for i := 2 to m-1 do
      for j := i+m+1 to n-1 do
      begin
        snijden(0,m,i,j,x0,y0);
        snijden(1,m+1,i,j,x1,y1);
        add(inttostr(Margin+round(factor*(x0-cosarr[0])))+' '+inttostr(Margin+round(factor*(y0-sinarr[0])))+' moveto');
        add(inttostr(Margin+round(factor*(x1-cosarr[0])))+' '+inttostr(Margin+round(factor*(y1-sinarr[0])))+' lineto');
      end;
      if R_kleur.itemindex=1 then
      begin
        Add(pslines[7]);
        Add(pslines[8]);
        Add(pslines[6]);
        Add(pscolors[MyBlue]);
      end;
      for i := 2 to m-1 do
      begin
        add(inttostr(Margin)+' '+inttostr(Margin)+' moveto');
        snijden(0,i,1,m+1,x0,y0);
        add(inttostr(Margin+round(factor*(x0-cosarr[0])))+' '+inttostr(Margin+round(factor*(y0-sinarr[0])))+' lineto');
        add(inttostr(Margin+round(factor*(cosarr[1]-cosarr[0])))+' '+inttostr(Margin)+' moveto');
        snijden(1,n-i+1,0,m,x0,y0);
        add(inttostr(Margin+round(factor*(x0-cosarr[0])))+' '+inttostr(Margin+round(factor*(y0-sinarr[0])))+' lineto');
      end;
      if R_kleur.itemindex=1 then
      begin
        Add(pslines[7]);
        Add(pslines[8]);
        Add(pslines[6]);
        Add(pscolors[MyRed]);
      end;
      add(inttostr(Margin)+' '+inttostr(Margin)+' moveto');
      add(inttostr(Margin+round(factor*(cosarr[1]-cosarr[0])))+' '+inttostr(Margin)+' lineto');
      add(inttostr(Margin+round(factor*(xM-cosarr[0])))+' '+inttostr(Margin+round(factor*(yM-sinarr[0])))+' lineto');
      add(inttostr(Margin)+' '+inttostr(Margin)+' lineto');
    end
    else
    begin
      m := n div 2+1;
      factor := (cosarr[m]-Margin)/(cosarr[m]-cosarr[0]);
      if R_kleur.itemindex=1 then Add(pscolors[MyBlack]);
      for i := 2 to m-1 do
      for j := m+1 to n-1 do
      begin
        snijden(0,m,i,j,x0,y0);
        snijden(1,m,i,j,x1,y1);
        add(inttostr(Margin+round(factor*(x0-cosarr[0])))+' '+inttostr(Margin+round(factor*(y0-sinarr[0])))+' moveto');
        add(inttostr(Margin+round(factor*(x1-cosarr[0])))+' '+inttostr(Margin+round(factor*(y1-sinarr[0])))+' lineto');
      end;
      if R_kleur.itemindex=1 then
      begin
        Add(pslines[7]);
        Add(pslines[8]);
        Add(pslines[6]);
        Add(pscolors[MyBlue]);
      end;
      for i := 2 to m-1 do
      begin
        add(inttostr(Margin)+' '+inttostr(Margin)+' moveto');
        snijden(0,i,1,m,x0,y0);
        add(inttostr(Margin+round(factor*(x0-cosarr[0])))+' '+inttostr(Margin+round(factor*(y0-sinarr[0])))+' lineto');
        add(inttostr(Margin+round(factor*(cosarr[1]-cosarr[0])))+' '+inttostr(Margin)+' moveto');
        snijden(1,n-i+1,0,m,x0,y0);
        add(inttostr(Margin+round(factor*(x0-cosarr[0])))+' '+inttostr(Margin+round(factor*(y0-sinarr[0])))+' lineto');
      end;
      if R_kleur.itemindex=1 then
      begin
        Add(pslines[7]);
        Add(pslines[8]);
        Add(pslines[6]);
        Add(pscolors[MyRed]);
      end;
      add(inttostr(Margin)+' '+inttostr(Margin)+' moveto');
      add(inttostr(Margin+round(factor*(cosarr[1]-cosarr[0])))+' '+inttostr(Margin)+' lineto');
      add(inttostr(Margin+round(factor*(cosarr[m]-cosarr[0])))+' '+inttostr(Margin+round(factor*(sinarr[m]-sinarr[0])))+' lineto');
      add(inttostr(Margin)+' '+inttostr(Margin)+' lineto');
    end;
  end;
end;

procedure TF_nhoek.ListingNSter;
var
  i, j, k, m, s : integer;
begin
  s := S_Ster.value;
  with Listbox1.Items do
  begin
    if R_kleur.itemindex=1 then
    begin
      if R_vulling.ItemIndex = 0 then
      begin
        Add(pscolors[MyBlack]);
        for i := 0 to n-1 do
        for j := i+s+2 to n do
        if j+s+1 < i+n then
        begin
          add(inttostr(round(cosarr[i]))+' '+inttostr(round(sinarr[i]))+' moveto');
          add(inttostr(round(cosarr[j]))+' '+inttostr(round(sinarr[j]))+' lineto');
        end;
        Add(pslines[7]);
        Add(pslines[8]);
        Add(pslines[6]);
        Add(pscolors[MyRed]);
        if n mod 2 = 0 then
        begin
          m := n div 2;
          for i := 0 to m-1 do
          begin
            add(inttostr(round(cosarr[i]))+' '+inttostr(round(sinarr[i]))+' moveto');
            add(inttostr(round(cosarr[i+m]))+' '+inttostr(round(sinarr[i+m]))+' lineto');
          end;
        end;
      end;
        Add(pslines[7]);
        Add(pslines[8]);
        Add(pslines[6]);
        Add(pscolors[MyBlue]);
      for i := 0 to n-1 do
      begin
        if i+s+1 < n then j := i+s+1 else j := i+s-n+1;
        add(inttostr(round(cosarr[i]))+' '+inttostr(round(sinarr[i]))+' moveto');
        add(inttostr(round(cosarr[j]))+' '+inttostr(round(sinarr[j]))+' lineto');
      end;
    end
    else
    begin
      if R_vulling.ItemIndex = 0 then
      begin
        for i := 0 to n-1 do
        for j := i+s+1 to n do
        if j+s < i+n then
        begin
          add(inttostr(round(cosarr[i]))+' '+inttostr(round(sinarr[i]))+' moveto');
          add(inttostr(round(cosarr[j]))+' '+inttostr(round(sinarr[j]))+' lineto');
        end;
      end
      else
      begin
        for i := 0 to n-1 do
        begin
          if i+s+1 < n then j := i+s+1 else j := i+s-n+1;
          add(inttostr(round(cosarr[i]))+' '+inttostr(round(sinarr[i]))+' moveto');
          add(inttostr(round(cosarr[j]))+' '+inttostr(round(sinarr[j]))+' lineto');
        end;
      end;
    end;
  end;
end;

procedure TF_nhoek.B_ExitClick(Sender: TObject);
begin
  Close;
end;

end.
